-- main.lua

-- Implements the main plugin entrypoint





-- Configuration
--  Use prefixes or not.
--  If set to true, messages are prefixed, e. g. "[FATAL]". If false, messages are colored.
g_UsePrefixes = false

-- Initialise variables
CACenabled = true
-- Called by Cuberite on plugin start to initialize the plugin
function Initialize(Plugin)
	Plugin:SetName("CoreAntiCheat")
	Plugin:SetVersion(tonumber(g_PluginInfo["Version"]))

	-- Register for all hooks needed
    cPluginManager:AddHook(cPluginManager.HOOK_PLAYER_MOVING, OnPlayerMove);
    cPluginManager:AddHook(cPluginManager.HOOK_PLAYER_JOINED, OnPlayerJoin);
    cPluginManager:AddHook(cPluginManager.HOOK_PLUGINS_LOADED, OnPluginsLoad);
    cPluginManager:AddHook(cPluginManager.HOOK_TICK, OnTick);



	-- Load the InfoReg shared library:
	dofile(cPluginManager:GetPluginsPath() .. "/InfoReg.lua")

	-- Bind all the commands:
	RegisterPluginInfoCommands()

	-- Bind all the console commands:
	RegisterPluginInfoConsoleCommands()

	LOG("Initialised " .. Plugin:GetName() .. " v." .. Plugin:GetVersion())

	return true
end

function OnDisable()
	LOG( "Disabled CoreAntiCheat!" )
end
function OnEnable()
	LOG( "Enabled CoreAntiCheat!" )
end

local function IncrementMovePackets(aPlayer)
    aPlayer.MovePackets = aPlayer.MovePackets + 1
end

local function IncrementTickCount(aPlayer)
    aPlayer.TickCount = aPlayer.TickCount + 1
end

local function CalculatePacketsCount(aPlayer)
    aPlayer.PacketsCount = aPlayer.PacketsCount + aPlayer.MovePackets
end

function OnPluginsLoad()
    local ForEachPlayer = function(aPlayer)
		aPlayer.CheckTick = 0
        aPlayer.MovePackets = 0
        aPlayer.TickCount = 0
        aPlayer.PacketsCount = 0
        if table.contains(aPlayer:GetPermissions(), "*") then
            aPlayer.Check = false
        elseif table.contains(aPlayer:GetPermissions(), "coreanticheat.ignore") then
            aPlayer.Check = false
        else
            aPlayer.Check = true
        end
	end
    cRoot:Get():ForEachPlayer(ForEachPlayer)
end

function OnPlayerJoin(aPlayer)
    aPlayer.CheckTick = 0
    aPlayer.MovePackets = 0
    aPlayer.TickCount = 0
    aPlayer.PacketsCount = 0
    if table.contains(aPlayer:GetPermissions(), "*") then
        aPlayer.Check = false
    elseif table.contains(aPlayer:GetPermissions(), "coreanticheat.ignore") then
        aPlayer.Check = false
    else
        aPlayer.Check = true
    end
end

function table.contains(table, element)
  for _, value in pairs(table) do
    if value == element then
      return true
    end
  end
  return false
end

-- Command Functions
function CoreAntiCheatCommand(Split, aPlayer, World)
	if Split[2] == "toggle" then
		if CACenabled then
			CACenabled = false
			aPlayer:SendMessageInfo("CoreAntiCheat Disabled!")
		else
			CACenabled = true
			aPlayer:SendMessageInfo("CoreAntiCheat Enabled!")
		end
	else
		if CACenabled then
			if Split[2] == "config" then
				aPlayer:SendMessageInfo("-- Config --")
				aPlayer:SendMessageInfo("MovementRestriction: " .. getconfig(2) .. "/10")
			elseif Split[2] == "myid" then
				aPlayer:SendMessage(Player:GetUniqueID())
				aPlayer:SendMessageFailure("Incorrect Argument")
			end
		else
			aPlayer:SendMessageFailure("CoreAntiCheat is disabled!")
		end
	end
	return true
end

function CoreAntiCheatConsoleCommand(Split)
	if Split[2] == "toggle" then
		if CACenabled then
			CACenabled = false
			LOG("CoreAntiCheat Disabled!")
		else
			CACenabled = true
			LOG("CoreAntiCheat Enabled!")
		end
	else
		if CACenabled then
			if Split[2] == "test" then
				cRoot:Get():BroadcastChat("test")
			elseif Split[2] == "config" then
				LOG("-- Config --")
				LOG("MovementRestriction: " .. getconfig(2))
            elseif Split[2] == "tplist" then
				if Split[3] ~= nil then
                    LOG("Value: " .. TeleportingPlayers[1])
				end
			else
				LOG("Incorrect Argument")
			end
		else
			LOG("CoreAntiCheat is disabled!")
		end
	end
	return true
end

function OnPlayerMove(aPlayer, OldPosition, NewPosition)
    if CACenabled and aPlayer.Check == true then
        if not(pcall(IncrementMovePackets, aPlayer)) then
            aPlayer.MovePackets = 0
            LOG("MovePacket Error - " + aPlayer)
            if getconfig(1) then
                aPlayer:SendMessage("MovePacket Error")
            end
        end
        if aPlayer.CheckTick == 0 then
            if not(aPlayer:IsRiding()) then
                OldPosition = OldPosition
                -- Uses vectors to compare x and z displacement
                Displacement = math.sqrt(((NewPosition.x-OldPosition.x)*(NewPosition.x-OldPosition.x))+((NewPosition.z-OldPosition.z)*(NewPosition.z-OldPosition.z)))
                AntiCheatMovementChecks(Displacement, aPlayer, OldPosition) -- Calls the function to check legitimacy
            end
        else
            aPlayer.CheckTick = aPlayer.CheckTick - 1
        end
    end
end

function OnTick(TickTime)
    if CACenabled then
        local ForEachPlayerTick = function(aPlayer)
            if aPlayer.Check == true then
                if not(pcall(IncrementTickCount, aPlayer)) then
                    aPlayer.TickCount = 0
                end
                IncrementTickCount(aPlayer)
                if not(pcall(CalculatePacketsCount, aPlayer)) then
                    aPlayer.PacketsCount = 0
                end
                CalculatePacketsCount(aPlayer)
                aPlayer.MovePackets = 0
                if aPlayer.TickCount > 40 then
                    if aPlayer.PacketsCount > 60 then
                        AddPlayerToBanlist(aPlayer, "Timer Hack/Packet Spoofing", "CoreAntiCheat")
                    end
                    if getconfig(1) then
                        aPlayer:SendMessage(aPlayer.PacketsCount)
                    end
                    aPlayer.PacketsCount = 0
                    aPlayer.TickCount = 0
                end
            end
        end
        cRoot:Get():ForEachPlayer(ForEachPlayerTick)
    end
end
-- AntiCheat Movement Logic

function AntiCheatMovementChecks(Displacement, aPlayer, OldPosition)
    if aPlayer:CanFly() then
        if getconfig(2) > 0.5 then -- Checks if flying is being regulated
            
            -- Calculates approximate max flying speed with ping taken into account
            local MaxFlyingSpeed = (aPlayer:GetFlyingMaxSpeed() + (0.05 * getconfig(3)) + (getconfig(2) * 0.001))
            
            if getconfig(1) then
                aPlayer:SendMessage(Displacement .. "/" .. MaxFlyingSpeed .. " Multiplyer: " .. aPlayer:GetFlyingMaxSpeed())
                aPlayer:SendMessage(aPlayer.CheckTick)
            end
            
            if Displacement > MaxFlyingSpeed then
                aPlayer.CheckTick = 8
                aPlayer:SendMessageFailure("You Moved Too Fast")
                aPlayer:TeleportToCoords(OldPosition.x, OldPosition.y, OldPosition.z)
            end
        end
    else
        if getconfig(3) > 0.5 then -- Checks if running is being regulated
            -- Calculates approximate max running speed with ping taken into account
            local MaxRunningSpeed = (aPlayer:GetSprintingMaxSpeed() + (0.05 * getconfig(4)) + (getconfig(2) * 0.001) - 0.75)
            
            if getconfig(1) then
                aPlayer:SendMessage(Displacement .. "/" .. MaxRunningSpeed .. " Multiplyer: " .. aPlayer:GetSprintingMaxSpeed())
                aPlayer:SendMessage(aPlayer.CheckTick)
            end
            
            if Displacement > MaxRunningSpeed then
                aPlayer.CheckTick = math.random(4,5)
                aPlayer:SendMessageFailure("You Moved Too Fast")
                aPlayer:TeleportToCoords(OldPosition.x, OldPosition.y, OldPosition.z)
            end
        end
    end
end